import { CollectionBase, MultipleSelection } from "@react-types/shared";
import { GridCollection, GridNode, GridRow } from "@react-types/grid";
import { Key } from "react";
import { SelectionManager } from "@react-stately/selection";
export interface GridState<T, C extends GridCollection<T>> {
    collection: C;
    disabledKeys: Set<Key>;
    selectionManager: SelectionManager;
}
interface GridStateOptions<T, C extends GridCollection<T>> extends CollectionBase<T>, MultipleSelection {
    collection: C;
}
export function useGridState<T extends object, C extends GridCollection<T>>(props: GridStateOptions<T, C>): GridState<T, C>;
interface GridCollectionOptions<T> {
    columnCount: number;
    items: GridRow<T>[];
    visitNode?: (cell: GridNode<T>) => GridNode<T>;
}
export class GridCollection<T> implements GridCollection<T> {
    keyMap: Map<Key, GridNode<T>>;
    columnCount: number;
    rows: GridNode<T>[];
    constructor(opts?: GridCollectionOptions<T>);
    [Symbol.iterator](): Generator<GridNode<T>, void, undefined>;
    get size(): number;
    getKeys(): IterableIterator<string | number>;
    getKeyBefore(key: Key): string | number;
    getKeyAfter(key: Key): string | number;
    getFirstKey(): string | number;
    getLastKey(): string | number;
    getItem(key: Key): GridNode<T>;
}

//# sourceMappingURL=types.d.ts.map
